aboutsummaryrefslogtreecommitdiffstats
path: root/scripts/is_rust_module.sh
diff options
context:
space:
mode:
authorDaniel Xu <dxu@dxuuu.xyz>2022-08-04 12:55:07 +0200
committerMiguel Ojeda <ojeda@kernel.org>2022-09-28 09:02:06 +0200
commite4b69cb9a99a567d1611f9cced92f475ae224cdb (patch)
treec897d5caa71194e33083a251e549f5cbb8b1e2af /scripts/is_rust_module.sh
parentscripts: add `rust_is_available.sh` (diff)
downloadlinux-dev-e4b69cb9a99a567d1611f9cced92f475ae224cdb.tar.xz
linux-dev-e4b69cb9a99a567d1611f9cced92f475ae224cdb.zip
scripts: add `is_rust_module.sh`
This script is used to detect whether a kernel module is written in Rust. It will later be used to disable BTF generation on Rust modules as BTF does not yet support Rust. Reviewed-by: Kees Cook <keescook@chromium.org> Reviewed-by: Greg Kroah-Hartman <gregkh@linuxfoundation.org> Co-developed-by: Alex Gaynor <alex.gaynor@gmail.com> Signed-off-by: Alex Gaynor <alex.gaynor@gmail.com> Co-developed-by: Wedson Almeida Filho <wedsonaf@google.com> Signed-off-by: Wedson Almeida Filho <wedsonaf@google.com> Signed-off-by: Daniel Xu <dxu@dxuuu.xyz> Co-developed-by: Miguel Ojeda <ojeda@kernel.org> Signed-off-by: Miguel Ojeda <ojeda@kernel.org>
Diffstat (limited to '')
-rwxr-xr-xscripts/is_rust_module.sh16
1 files changed, 16 insertions, 0 deletions
diff --git a/scripts/is_rust_module.sh b/scripts/is_rust_module.sh
new file mode 100755
index 000000000000..28b3831a7593
--- /dev/null
+++ b/scripts/is_rust_module.sh
@@ -0,0 +1,16 @@
+#!/bin/sh
+# SPDX-License-Identifier: GPL-2.0
+#
+# is_rust_module.sh module.ko
+#
+# Returns `0` if `module.ko` is a Rust module, `1` otherwise.
+
+set -e
+
+# Using the `16_` prefix ensures other symbols with the same substring
+# are not picked up (even if it would be unlikely). The last part is
+# used just in case LLVM decides to use the `.` suffix.
+#
+# In the future, checking for the `.comment` section may be another
+# option, see https://github.com/rust-lang/rust/pull/97550.
+${NM} "$*" | grep -qE '^[0-9a-fA-F]+ r _R[^[:space:]]+16___IS_RUST_MODULE[^[:space:]]*$'